package com.x.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import com.x.pojo.*;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
public class Music {
	
	/**
	 * ȡԴ
	 * @param like
	 * @return
	 * @throws IOException 
	 */
	public static String Html(String like) throws IOException
	{
		StringBuffer sb = new StringBuffer();
		InputStreamReader reader = null;
		BufferedReader bd = null;
		try {
			//
			URL url = new URL(like);
			//
			URLConnection uc = url.openConnection();
			//αװ
			uc.setRequestProperty("USer-Agent", "java");
			//ļ
			InputStream inputStream = uc.getInputStream();
			reader = new InputStreamReader(inputStream,"utf-8");
			bd = new BufferedReader(reader);
			
			String html = "";
			while((html=bd.readLine())!=null)
			{
				sb.append(html+"\n");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}finally {
			bd.close();
			if(reader!=null)reader.close();
		}
		return sb.toString();
	}
	/**
	 * ȡ
	 * @param url
	 * @return
	 * @throws IOException
	 */
	public static music mc(int id,String hash) throws IOException
	{
		com.x.pojo.music music = null;
		if(id!=0)
		{
			String Urlget = "http://www.kugou.com/yy/index.php?r=play/getdata&hash="+hash+"&album_id="+id+"&_=1509095251147";
			String html = Music.Html(Urlget);
			System.out.println(html);
			JSONObject json1 = JSONObject.fromObject(html);
			JSONObject json = (JSONObject) json1.get("data");
			//
			String author_name = json.getString("author_name");
			//
			String song_name = json.getString("song_name");
			//lyrics
			String lyrics = json.getString("lyrics");
			//ַ
			String play_url = json.getString("play_url");
			music = new music(author_name,song_name,lyrics,play_url);
		}
		else
		{
			String Urlget = "http://www.kugou.com/yy/index.php?r=play/getdata&hash="+hash+"&_=1509095251147";
			String html = Music.Html(Urlget);
			System.out.println(html);
			JSONObject json1 = JSONObject.fromObject(html);
			JSONObject json = (JSONObject) json1.get("data");
			//
			String author_name = json.getString("author_name");
			//
			String song_name = json.getString("song_name");
			//lyrics
			String lyrics = json.getString("lyrics");
			//ַ
			String play_url = json.getString("play_url");
			 music = new music(author_name,song_name,lyrics,play_url);
		}
		

		
		if(music!=null)
		{
			return music;
		}
		return null;
		
	}
	/**
	 * 
	 * @param info
	 * @return
	 */
	public static List<MusicInfo> Info(String info)
	{
		List<MusicInfo> list = new ArrayList<MusicInfo>();

		String url = "http://songsearch.kugou.com/song_search_v2?callback=jQuery1124034399245126868405_1509165994732&keyword="+info+"&page=1&pagesize=30&userid=1&clientver=&platform=WebFilter&tag=em&filter=2&iscorrection=1&privilege_filter=1&_=1509165994737";
		try {
			String html = Music.Html(url);
			
			int ii = html.indexOf("{");
			String hh = html.substring(ii);
			int ll = hh.length();
			
			String ss = hh.substring(0, (ll-2));
			JSONObject json = JSONObject.fromObject(ss);
			JSONObject json1 = (JSONObject) json.get("data");
			JSONArray json2 =null;
			if(json1.get("lists")!=null)
			{
				json2 = (JSONArray) json1.get("lists");
			}
			
			
			/**
			 * json{  { } , {}, {}}
			 */
			if(json2!=null){
				for(int i = 0;i<json2.size();i++)
				{
					Object object = json2.get(i);
					//
					JSONObject js = (JSONObject) json2.get(i);
					String FileHash = (String) js.get("FileHash");
					//
					String HQFileHash = (String) js.get("HQFileHash");
					//
					String SQFileHash = (String) js.get("SQFileHash");
					//mv
					String MvHash = (String) js.get("MvHash");
					//id
					int AlbumID = 0;
					if(!js.get("AlbumID").equals("")){
						AlbumID = Integer.parseInt(js.get("AlbumID").toString());
					}
					
					//Ϣ
					String FileName = (String) js.get("FileName");
					//רϢ
					String AlbumName = (String) js.get("AlbumName");
					music music =null;
					if(AlbumID!=0)
					{
						music = Music.mc(AlbumID,FileHash);
						
					}
					else
					{
						music = Music.mc(AlbumID,FileHash);
					}
						MusicInfo mi = new MusicInfo(FileHash,HQFileHash,SQFileHash,AlbumID,MvHash,AlbumName,FileName,music.getPlay_url());
						list.add(mi);
					
					
					
				}
			}
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return list;
	}
	
	public static void main(String[] args) throws IOException {

		
	
	}

}
